#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int fib_seq (int n)
{
  if (n < 2)
    return n;

  int r1, r2;
  
  r1 = fib_seq (n - 1);
  r2 = fib_seq (n - 2);

  return r1 + r2;
}

int fib_par (int n)
{
  if (n < 2)
    return n;

  int r1, r2;

  #pragma omp task shared(r1) shared(n)
  r1 = fib_par (n - 1);

  #pragma omp task shared(r2) firstprivate(n)
  r2 = fib_par (n - 2);

  #pragma omp taskwait

  return r1 + r2;
}

int main (int argc, char *argv[])
{
  int n = 15;
  int r;

  if (argc > 1)
    n = atoi (argv[1]);

  #pragma omp parallel shared(r)
  #pragma omp single
  r = fib_par (n);

  printf ("fib (%d) = %d\n", n, r);

  return EXIT_SUCCESS;
}
