#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

static int is_prime (int i)
{
  if ((i & 1) == 0)
    return i == 2;
  
  for (int d = 3; d*d <= i; d += 2) {
    if ((i / d) * d == i)
      return 0;
  }
  return 1;
}

static void test_prime (int i)
{
  if (is_prime (i))
    printf ("%d is a prime number (found by Thread %d)\n", i, omp_get_thread_num ());
}

int main ()
{
  #pragma omp parallel
  #pragma omp single
  {
    int k = 0;

    while (k < 25) {
      #pragma omp task firstprivate(k)
      test_prime (k);
      k++;
    }
  }

  return EXIT_SUCCESS;
}
